PORTB   EQU     6 
TRISB   EQU     86H
OPTREG  EQU     81H
STATUS  EQU     3
CARRY   EQU     0
RP0     EQU     5
MSB     EQU     3               ;     
;
        CLRF    PORTB           ;  
        BSF     STATUS,RP0      ;   1
        CLRF    TRISB^80H       ;   PORTB   
        MOVLW   0AH
        MOVWF   OPTREG^80H      ;    WDT  (1:4)
        BCF     STATUS,RP0      ;   0
        INCF    PORTB,F         ;   
        BCF     STATUS,CARRY    ;  CARRY
LEFT    SLEEP                   ;  WDT ("watchdog" )
        RLF     PORTB,F         ;   
        BTFSS   PORTB,MSB       ;   ?
        GOTO    LEFT            ;  - 
RIGHT   SLEEP                   ;  WDT
        RRF     PORTB,F         ;   
        BTFSS   PORTB,0         ;   ?
        GOTO    RIGHT           ;  - 
        GOTO    LEFT            ;  
        END
