#include p16f877.inc

;    16  8    24 . 
;  ,       
;.   0x532af2    0x532a*0xff+0xf2
;        Mul1Lo  Mul1Hi
;(    ),   Mul2.   Mul16_8.
;   Mul1Lo, Mul1Hi  ResHi (,    )


;    24  16    .
;       Mul1Lo, Mul1Hi  ResHi
;(    ),   DivLo, DivHi.   Div24_16.
;   Mul1Lo, Mul1Hi  ResHi (,    )


;       



 
;, 0
	cblock 0x20	

	Cnt

	DivLo
	DivHi


	Mul1Lo
	Mul1Hi
	ResHi
	Res1
	Res2
	Res3
	Mul2

	
	CntDiv

	Temp
	Temp1
	Temp2
	Temp3
	Temp4
	Temp5


	Flag

	endc


#define	Tmp	Flag,0






	goto Begin

Intrp	org	0x4
; 

	retfie





;/  168.    Mul1Lo,Mul1Hi  Mul2
;   Mul1Lo, Mul1Hi, ResHi.
;  200 .
Mul16_8 
	clrf Temp
	clrf Temp1
	clrf Temp2
	clrf ResHi
	movlw 8
	movwf Cnt
Ml_3
	rrf Mul2,1
	btfss STATUS,C
	goto Ml_5
	movf Mul1Lo,0
	addwf Temp1,1
	btfss  STATUS,C
	goto Ml_1
	incfsz Temp2,1
	goto Ml_1
	incf ResHi,1
	
Ml_1
	movf Mul1Hi,0
	addwf Temp2,1
	btfss  STATUS,C
	goto Ml_2
	incf ResHi,1
	
Ml_2	movf Temp,0
	addwf ResHi,1
Ml_5
	decfsz Cnt,1
	goto Ml_4
	goto Fin_Mul

Ml_4	bcf STATUS,C
	rlf Mul1Lo,1
	rlf Mul1Hi,1
	rlf Temp,1
	goto Ml_3	
Fin_Mul
	movf Temp1,0
	movwf Mul1Lo
	movf Temp2,0
	movwf Mul1Hi
	return




Sub
	bcf Tmp
	movf DivLo,0		
	subwf Temp,1		
	btfsc STATUS,C		
	goto sub2nd		
	decf Temp2,1		
	movlw 0xff		
	subwf Temp2,0		
	btfss STATUS,Z		
	goto sub2nd		
	decf Temp3,1		
	movlw 0xff		
	subwf Temp3,0		
	btfsc STATUS,Z		
	bsf Tmp			


sub2nd
	movf DivHi,0
	subwf Temp2,1
	btfsc STATUS,C
	return
	decf Temp3,1
	movlw 0xff
	subwf Temp3,0
	btfsc STATUS,Z
	bsf Tmp
	return



;/  Mul1Lo, Mul1Hi, ResHi  DivLo, DivHi.    Mul1Lo, Mul1Hi.
;!!! Mul1Lo, Mul1Hi, ResHi  Res1,Res2,Res3       
Div24_16
	clrf Temp
	clrf Temp2
	clrf Temp3
	clrf Cnt
	clrf Res1
	clrf Res2
	clrf Res3


	movlw 0xf0
	andwf DivHi,0
	btfsc STATUS,Z
	goto chknxt
	
	movf ResHi,0
	movwf Temp2
	movf Mul1Hi,0
	movwf Temp
	movlw .2
	movwf CntDiv
	goto StartDiv	
	
	
chknxt
	movf DivHi,1
	btfsc STATUS,Z
	goto chknxt1
	movlw 0xf0
	andwf ResHi,0
	movwf Temp2
	swapf Temp2,1
	
	movlw 0x0f
	andwf ResHi,0
	movwf Temp
	swapf Temp,1

	movlw 0xf0
	andwf Mul1Hi,0
	movwf Temp3
	swapf Temp3,0
	iorwf Temp,1
	clrf Temp3
	movlw .3
	movwf CntDiv
	goto StartDiv
chknxt1

	movlw 0xf0
	andwf DivLo,0
	btfsc STATUS,Z
	goto chknxt2

	movf ResHi,0
	movwf Temp
	movlw .4
	movwf CntDiv
	goto StartDiv
chknxt2
	movlw 0xf0
	andwf ResHi,0
	movwf Temp
	swapf Temp,1
	movlw .5
	movwf CntDiv

StartDiv


sbagn
	call Sub
	btfsc Tmp
	goto FinSub
	incf Cnt,1
	goto sbagn




FinSub
	movf DivLo,0
	addwf Temp,1	
	btfss STATUS,C
	goto add2nd
	incfsz Temp2,1
	goto add2nd
	incf Temp3,1
	
add2nd
	movf DivHi,0	
	addwf Temp2,1
	btfss STATUS,C	
	goto jpqm
	incf Temp3,1
jpqm
	bcf STATUS,C
	rrf CntDiv,0
	movwf FSR
	movlw Res1
	addwf FSR,1
	btfss CntDiv,0
	goto nnhjuq
	swapf Cnt,0
	iorwf INDF,1
	goto ffr
nnhjuq
	movf Cnt,0
	iorwf INDF,1
ffr



	decf CntDiv,1
	movlw 0xff
	subwf CntDiv,0
	btfss STATUS,Z


	goto notFin
	goto FinDiv

notFin	

	bcf STATUS,C
	rlf Temp,1
	rlf Temp2,1
	rlf Temp3,1
	bcf STATUS,C	
	rlf Temp,1
	rlf Temp2,1
	rlf Temp3,1
	bcf STATUS,C	
	rlf Temp,1
	rlf Temp2,1
	rlf Temp3,1
	bcf STATUS,C	
	rlf Temp,1
	rlf Temp2,1
	rlf Temp3,1



	bcf STATUS,C
	rrf CntDiv,0
	movwf FSR
	movlw Mul1Lo
	addwf FSR,1
	btfsc CntDiv,0
	goto nnhq
	movlw 0x0f
	andwf INDF,0
	iorwf Temp,1
	goto jjddsak
nnhq
	swapf INDF,0
	andlw 0x0f
	iorwf Temp,1
jjddsak
	clrf Cnt
	goto sbagn	
	




FinDiv
	bcf STATUS,C		;
	rrf DivHi,1
	rrf DivLo,1
	movf DivHi,0
	subwf Temp2,0
	btfss STATUS,C
	goto dsgfadsg
	btfss STATUS,Z
	goto cxv
	movf DivLo,0
	subwf Temp,0
	btfss STATUS,C	
	goto dsgfadsg
cxv
	incfsz Res1,1
	goto dsgfadsg
	incfsz Res2,1
	goto dsgfadsg
	incf Res3,1

dsgfadsg
	movf Res1,0
	movwf Mul1Lo
	movf Res2,0
	movwf Mul1Hi
	movf Res3,0
	movwf ResHi
	return


Begin			; 

;   .   53908*151,   
;  0xd294*0x97

	movlw 0xd2	;   
	movwf Mul1Hi	;

	movlw 0x94	;   
	movwf Mul1Lo	;

	movlw 0x97	; 
	movwf Mul2	;

	call Mul16_8	;.    ResHi, Mul1Hi, Mul1Lo 
			;(0x7c354c  8140108)   170 





;   .  4769992  7650,   
;  0x48c8c8*0x1de2


	movlw 0x48	;  
	movwf ResHi	;

	movlw 0xc8	;  
	movwf Mul1Hi	;

	movlw 0xc8	;  
	movwf Mul1Lo	;

	
	movlw 0x1d	;  
	movwf DivHi	;

	movlw 0xe2	;  
	movwf DivLo	;


	call Div24_16	;.    ResHi, Mul1Hi, Mul1Lo 
			;(0x279  624 (  623.528)) 
			;   790 


	end
