	list      p=16f84a
        __CONFIG 03FFBh
;
;  
;
;  p pp
TMR0            EQU     01h
PC              EQU     02h
STATUS          EQU     03h
FSR             EQU     04h
; pp /
CNTRLPORT       EQU     05h
DATAPORT        EQU     06h
;  
I1              EQU     0Ch
I2              EQU     0Dh
L1              EQU     0Eh
L2              EQU     0Fh
L3              EQU     10h
L0              EQU     11h
LL              EQU     12h
I3              EQU     13h
I4              EQU     14h
;  pp STATUS
C               EQU     0h
DC              EQU     1h
Z               EQU     2h
PD              EQU     3h
TO              EQU     4h
RP              EQU     5h
; p pp
TRISA           EQU     85h
TRISB           EQU     86h
;    p /
INITA           EQU     B'00011000'
INITB           EQU     B'00000000'
;
;  
;
;   
        ORG     0
        GOTO    BEGIN
;
        ORG     100h
BEGIN
;  
        BCF     STATUS,RP    ;  0
        CLRF    CNTRLPORT    ;  CNTRLPORT
        MOVLW   INITA        ;p B'00011000'  pp W
        BSF     STATUS,RP    ;  1
        MOVWF   TRISA        ;      
;  
        BCF     STATUS,RP    ;  0
        CLRF    DATAPORT     ;  DATAPORT
        MOVLW   INITB        ;p B'00000000'  pp W
        BSF     STATUS,RP    ;  1
        MOVWF   TRISB        ;       
;
        BCF     STATUS,RP    ;  0
;
NACALO                       ; 
       MOVLW    0FFh
       MOVWF    DATAPORT     ;  
START
       MOVLW    B'00000000'
       MOVWF    CNTRLPORT    ;  
       CALL     LEDN         ;  
       GOTO     START        ;  
;
LEDN
       BTFSS    CNTRLPORT,3  ;  , 
       CALL     LED0         ; 0,  L0=0h
       BTFSC    CNTRLPORT,3  ;  , 
       CALL     LED1         ; 1,  L0=1h
       RETURN                ;  
;
LED0
       MOVLW    B'11000000'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED1
       MOVLW    B'11111001'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED2
       MOVLW    B'10100100'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED3
       MOVLW    B'10110000'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED4
       MOVLW    B'10011001'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED5
       MOVLW    B'10010010'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED6
       MOVLW    B'10000010'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED7
       MOVLW    B'11111000'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED8
       MOVLW    B'10000000'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED9
       MOVLW    B'10010000'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
TOCKA
       MOVLW    B'01111111'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
ERRORR
       MOVLW    B'00000110'
       MOVWF    CNTRLPORT    ;  
       MOVLW    B'10000110'
       MOVWF    DATAPORT
       MOVLW    013h         ; 013h   W
       MOVWF    I4           ;  W  I4
       CALL     PAUSE2
       GOTO     NACALO
       RETURN                ;  
;
PAUSE
       MOVLW    0FFh         ; 0FFh   W
       MOVWF    I1           ;  W  I1
LOOP
       DECFSZ   I1,1         ; I1  1
       GOTO     LOOP         ;  ,    =0
       RETURN                ;  
;
PAUSE2
       MOVLW    0FFh         ; 0FFh   W
       MOVWF    I3           ;  W  I3
LOOP3
       MOVLW    0FFh         ; 0FFh   W
       MOVWF    I2           ;  W  I2
LOOP2
       DECFSZ   I2,1         ; I2  1
       GOTO     LOOP2        ;  ,    =0
       DECFSZ   I3,1         ; I3  1
       GOTO     LOOP3        ;    LOOP3,    =0
       DECFSZ   I4,1         ; I4  1
       GOTO     PAUSE2       ;    PAUSE2,    =0
       RETURN                ;  
;
 END
;

