; pp    p pp
;
;
;  
;
;  p pp
TMR0            EQU     01h
PC              EQU     02h
STATUS          EQU     03h
FSR             EQU     04h
; pp /
CNTRLPORT       EQU     05h
DATAPORT        EQU     06h
;  
SCRATCH         EQU     0Ch
DIGIT           EQU     0Dh
;  pp STATUS
C               EQU     0h
DC              EQU     1h
Z               EQU     2h
PD              EQU     3h
TO              EQU     4h
RP              EQU     5h
; p pp
TRISA           EQU     85h
TRISB           EQU     86h
;    p /
INITA           EQU     B'00011000'
INITB           EQU     B'00000000'
;
;  
;
;   
        ORG     0
        GOTO    BEGIN
;
        ORG     100h
BEGIN
;  
        BCF     STATUS,RP    ;  0
        CLRF    CNTRLPORT    ;  CNTRLPORT
        MOVLW   INITA        ;p B'00011000'  pp W
        BSF     STATUS,RP    ;  1
        MOVWF   TRISA        ;      
;  
        BCF     STATUS,RP    ;  0
        CLRF    DATAPORT     ;  DATAPORT
        MOVLW   INITB        ;p B'00000000'  pp W
        BSF     STATUS,RP    ;  1
        MOVWF   TRISB        ;       
;
        BCF     STATUS,RP    ;  0
;
;    pp
START
       MOVLW    B'00000110'
       MOVWF    CNTRLPORT
       CALL     PEREBOR      ; 
       MOVLW    B'00000101'
       MOVWF    CNTRLPORT
       CALL     PEREBOR      ; 
       MOVLW    B'00000011'
       MOVWF    CNTRLPORT
       CALL     PEREBOR      ; 
       MOVLW    B'00000000'
       MOVWF    CNTRLPORT
       CALL     PEREBOR      ; 
       GOTO     START        ;  
;
PEREBOR
       CALL     LED0         ;  
       CALL     PAUSE        ; 
       CALL     LED1         ;  
       CALL     PAUSE        ; 
       CALL     LED2         ;  
       CALL     PAUSE        ; 
       CALL     LED3         ;  
       CALL     PAUSE        ; 
       CALL     LED4         ;  
       CALL     PAUSE        ; 
       CALL     LED5         ;  
       CALL     PAUSE        ; 
       CALL     LED6         ;  
       CALL     PAUSE        ; 
       CALL     LED7         ;  
       CALL     PAUSE        ; 
       CALL     LED8         ;  
       CALL     PAUSE        ; 
       CALL     LED9         ;  
       CALL     PAUSE        ; 
       CALL     TOCKA        ;  
       CALL     PAUSE        ; 
       CLRF     DATAPORT
       COMF     DATAPORT
       CALL     PAUSE        ; 
       RETURN                ;  
;
LED0
       MOVLW    B'11000000'
       MOVWF    DATAPORT
       RETURN                ;  
;
LED1
       MOVLW    B'11111001'
       MOVWF    DATAPORT
       RETURN                ;  
;
LED2
       MOVLW    B'10100100'
       MOVWF    DATAPORT
       RETURN                ;  
;
LED3
       MOVLW    B'10110000'
       MOVWF    DATAPORT
       RETURN                ;  
;
LED4
       MOVLW    B'10011001'
       MOVWF    DATAPORT
       RETURN                ;  
;
LED5
       MOVLW    B'10010010'
       MOVWF    DATAPORT
       RETURN                ;  
;
LED6
       MOVLW    B'10000010'
       MOVWF    DATAPORT
       RETURN                ;  
;
LED7
       MOVLW    B'11111000'
       MOVWF    DATAPORT
       RETURN                ;  
;
LED8
       MOVLW    B'10000000'
       MOVWF    DATAPORT
       RETURN                ;  
;
LED9
       MOVLW    B'10010000'
       MOVWF    DATAPORT
       RETURN                ;  
;
TOCKA
       MOVLW    B'01111111'
       MOVWF    DATAPORT
       RETURN                ;  
;
PAUSE
       MOVLW    0FFh         ; 0FFh   W
       MOVWF    SCRATCH      ;  W  SCRATCH
       MOVLW    0FFh         ; 0FFh   W
       MOVWF    DIGIT        ;  W  DIGIT
LOOP
       DECFSZ   SCRATCH,1    ; SCRATCH  1
       GOTO     LOOP         ;  ,    =0
       DECFSZ   DIGIT,1      ; DIGIT  1
       GOTO     LOOP         ;    LOOP,    =0
       RETURN                ;  
;
 END
;

