	list      p=16f84a
        __CONFIG 03FFBh
;
;  
;
;  p pp
TMR0            EQU     01h
PC              EQU     02h
STATUS          EQU     03h
FSR             EQU     04h
; pp /
CNTRLPORT       EQU     05h
DATAPORT        EQU     06h
;  
I1              EQU     0Ch
I2              EQU     0Dh
L1              EQU     0Eh
L2              EQU     0Fh
L3              EQU     10h
L0              EQU     11h
LL              EQU     12h
I3              EQU     13h
I4              EQU     14h
;  pp STATUS
C               EQU     0h
DC              EQU     1h
Z               EQU     2h
PD              EQU     3h
TO              EQU     4h
RP              EQU     5h
; p pp
TRISA           EQU     85h
TRISB           EQU     86h
;    p /
INITA           EQU     B'00011000'
INITB           EQU     B'00000000'
;
;  
;
;   
        ORG     0
        GOTO    BEGIN
;
        ORG     100h
BEGIN
;  
        BCF     STATUS,RP    ;  0
        CLRF    CNTRLPORT    ;  CNTRLPORT
        MOVLW   INITA        ;p B'00011000'  pp W
        BSF     STATUS,RP    ;  1
        MOVWF   TRISA        ;      
;  
        BCF     STATUS,RP    ;  0
        CLRF    DATAPORT     ;  DATAPORT
        MOVLW   INITB        ;p B'00000000'  pp W
        BSF     STATUS,RP    ;  1
        MOVWF   TRISB        ;       
;
        BCF     STATUS,RP    ;  0
;
NACALO                       ; 
       MOVLW    0FFh
       MOVWF    DATAPORT     ;  
       MOVLW    0h           ; 
;       MOVWF    L0           ;  
       MOVWF    L1           ; 
       MOVWF    L2           ; 
       MOVWF    L3           ; 
START
       MOVLW    0Ah
       XORWF    L1,0
       BTFSC    STATUS,Z     ; L1=A,   ADDL2
       CALL     ADDL2
       MOVLW    0Ah
       XORWF    L2,0
       BTFSC    STATUS,Z     ; L2=A,   ADDL3
       CALL     ADDL3
       MOVLW    0Ah
       XORWF    L3,0
       BTFSC    STATUS,Z     ; L3=A,   ERRORR
       CALL     ERRORR
       MOVLW    0FFh
       XORWF    L1,0
       BTFSC    STATUS,Z     ; L1=FF,   SUBL2
       CALL     SUBL2
       MOVLW    0FFh
       XORWF    L2,0
       BTFSC    STATUS,Z     ; L2=FF,   SUBL3
       CALL     SUBL3
       MOVLW    0FFh
       XORWF    L3,0
       BTFSC    STATUS,Z     ; L3=FF,   ERRORR
       CALL     ERRORR
       MOVLW    0FFh         ;    
       MOVWF    LL           ;  
POVTOR
       MOVF     L1,0         ; L1  W
       MOVWF    L0           ;  L0 W, L0:=L1
       MOVLW    B'00000110'
       MOVWF    CNTRLPORT    ;  
       CALL     LEDN         ;  
       MOVF     L2,0
       MOVWF    L0           ;L0:=L2
       MOVLW    B'00000101'
       MOVWF    CNTRLPORT    ;  
       CALL     LEDN         ;  
       MOVF     L3,0
       MOVWF    L0           ;L0:=L3
       MOVLW    B'00000011'
       MOVWF    CNTRLPORT    ;  
       CALL     LEDN         ;  
       DECFSZ   LL,1
       GOTO     POVTOR       ;  
       BTFSS    CNTRLPORT,3  ;  , 
       INCF     L1,1         ;    L1  1
       BTFSS    CNTRLPORT,4  ;  , 
       DECF     L1,1         ;    L1  1
       GOTO     START        ;  
;
ADDL2
       INCF     L2,1         ;L2:=L2+1
       MOVLW    0h
       MOVWF    L1           ;L1:=0
       RETURN                ;  
;
ADDL3
       INCF     L3,1         ;L3:=L3+1
       MOVLW    0h
       MOVWF    L2           ;L2:=0
       RETURN                ;  
;
SUBL2
       DECF     L2,1         ;L2:=L2+1
       MOVLW    9h
       MOVWF    L1           ;L1:=0
       RETURN                ;  
;
SUBL3
       DECF     L3,1         ;L3:=L3+1
       MOVLW    9h
       MOVWF    L2           ;L2:=0
       RETURN                ;  
;
LEDN
       MOVLW    0h
       XORWF    L0,0
       BTFSC    STATUS,Z
       CALL     LED0         ; 0,  L0=0h
       MOVLW    1h
       XORWF    L0,0
       BTFSC    STATUS,Z
       CALL     LED1         ; 1,  L0=1h
       MOVLW    2h
       XORWF    L0,0
       BTFSC    STATUS,Z
       CALL     LED2         ; 2,  L0=2h
       MOVLW    3h
       XORWF    L0,0
       BTFSC    STATUS,Z
       CALL     LED3         ; 3,  L0=3h
       MOVLW    4h
       XORWF    L0,0
       BTFSC    STATUS,Z
       CALL     LED4         ; 4,  L0=4h
       MOVLW    5h
       XORWF    L0,0
       BTFSC    STATUS,Z
       CALL     LED5         ; 5,  L0=5h
       MOVLW    6h
       XORWF    L0,0
       BTFSC    STATUS,Z
       CALL     LED6         ; 6,  L0=6h
       MOVLW    7h
       XORWF    L0,0
       BTFSC    STATUS,Z
       CALL     LED7         ; 7,  L0=7h
       MOVLW    8h
       XORWF    L0,0
       BTFSC    STATUS,Z
       CALL     LED8         ; 8,  L0=8h
       MOVLW    9h
       XORWF    L0,0
       BTFSC    STATUS,Z
       CALL     LED9         ; 9,  L0=9h
       MOVLW    0FFh
       MOVWF    DATAPORT     ;  
       RETURN                ;  
;
LED0
       MOVLW    B'11000000'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED1
       MOVLW    B'11111001'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED2
       MOVLW    B'10100100'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED3
       MOVLW    B'10110000'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED4
       MOVLW    B'10011001'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED5
       MOVLW    B'10010010'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED6
       MOVLW    B'10000010'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED7
       MOVLW    B'11111000'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED8
       MOVLW    B'10000000'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED9
       MOVLW    B'10010000'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
TOCKA
       MOVLW    B'01111111'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
ERRORR
       MOVLW    B'00000110'
       MOVWF    CNTRLPORT    ;  
       MOVLW    B'10000110'
       MOVWF    DATAPORT
       MOVLW    013h         ; 013h   W
       MOVWF    I4           ;  W  I4
       CALL     PAUSE2
       GOTO     NACALO
       RETURN                ;  
;
PAUSE
       MOVLW    0FFh         ; 0FFh   W
       MOVWF    I1           ;  W  I1
LOOP
       DECFSZ   I1,1         ; I1  1
       GOTO     LOOP         ;  ,    =0
       RETURN                ;  
;
PAUSE2
       MOVLW    0FFh         ; 0FFh   W
       MOVWF    I3           ;  W  I3
LOOP3
       MOVLW    0FFh         ; 0FFh   W
       MOVWF    I2           ;  W  I2
LOOP2
       DECFSZ   I2,1         ; I2  1
       GOTO     LOOP2        ;  ,    =0
       DECFSZ   I3,1         ; I3  1
       GOTO     LOOP3        ;    LOOP3,    =0
       DECFSZ   I4,1         ; I4  1
       GOTO     PAUSE2       ;    PAUSE2,    =0
       RETURN                ;  
;
 END
;

